/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_pwm.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_pwm.h"

/****************************************************************************/
/*	Local pre-processor symbols('#define')
****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
****************************************************************************/

/****************************************************************************/
/*	Local function prototypes('static')
****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
****************************************************************************/


/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
****************************************************************************/

/******************************************************************************
** \brief	 PWM_Config (complementary, no dead time)
** \param [in] 
**            	
** \return  none
** \note  
******************************************************************************/
void PWM_Config(void)
{
	//PWMģʽ
	EPWM_ConfigRunMode(EPWM_WFG_COMPLEMENTARY|EPWM_OC_INDEPENDENT); //ģʽ+ģʽ
	//PWMʱ	
	EPWM_ConfigChannelClk(EPWM0, EPWM_CLK_DIV_32);		
	//PWM Լռձ	
	EPWM_ConfigChannelPeriod(EPWM0, 0x12C0);

	EPWM_ConfigChannelSymDuty(EPWM0, 0x0960);

	//PWMļطʽΪԶ
	EPWM_EnableAutoLoadMode(EPWM_CH_0_MSK);
	//PWM
	EPWM_DisableReverseOutput(EPWM_CH_0_MSK|EPWM_CH_1_MSK); //رշ
	//PWM
	EPWM_EnableOutput(EPWM_CH_0_MSK|EPWM_CH_1_MSK);		//
	//PWM
	EPWM_DisableDeadZone(EPWM0);	
	//PWMж
//	PWM_EnableZeroInt(PWM_CH_0_MSK);				//PWMж
//	PWM_AllIntEnable();							//PWMж
//	IRQ_SET_PRIORITY(IRQ_PWM,IRQ_PRIORITY_HIGH);
//	IRQ_ALL_ENABLE();								//ж

	//PWMIO
//	GPIO_SET_MUX_MODE(P10CFG, GPIO_MUX_PG0);
//	GPIO_SET_MUX_MODE(P13CFG, GPIO_P13_MUX_PG1);

	//PWM					
	EPWM_Start(EPWM_CH_0_MSK);
}


